/***************************************************************************
                          cnf.cpp  -  description
                             -------------------
    begin                : Thu Jul 9 2006
    copyright            : (C) 2006-2009  Marian VooDooMan Meravy
    email                : ghostvoodooman@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

XTelnet - a simple telnet client
Copyright (C) 2006-2009  Marian VooDooMan Meravy
  (ghostvoodooman@users.sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

#include "cnf.h"

BEGIN_EVENT_TABLE(c_cnf_panel, wxPanel)
    EVT_CHECKBOX(Conf_ssl,  c_cnf_panel::OnSslCheckBox)
    EVT_BUTTON(Conf_ok_btn, c_cnf_panel::OnOkBtn)

    EVT_BUTTON(Conf_cas_btn,    c_cnf_panel::OnCAs_btn)
    EVT_BUTTON(Conf_crt_btn,    c_cnf_panel::OnCrt_btn)
    EVT_BUTTON(Conf_key_btn,    c_cnf_panel::OnKey_btn)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(c_cnf_frame, wxFrame)
    EVT_CLOSE(c_cnf_frame::OnClose)
END_EVENT_TABLE()

c_cnf_panel::c_cnf_panel(wxFrame *frame)
    : wxPanel(frame, -1)
{
    SetAutoLayout(true);

    int vertical_spacing=16;

    wxLayoutConstraints *c;

    m_utf8=new wxCheckBox(this, Conf_UTF8,_T("UTF-8"));
    c=new wxLayoutConstraints;
    c->top.Absolute(16);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_utf8->SetConstraints(c);
    m_utf8->Show();

    m_highlight=new wxCheckBox(this, Conf_Highlight,_T("Hightlight control characters like \\x01 (may consume a lot of CPU!)"));
    c=new wxLayoutConstraints;
    c->top.Below(m_utf8,5);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_highlight->SetConstraints(c);
    m_highlight->Show();

    m_local_echo=new wxCheckBox(this, Conf_LocalEcho,_T("Enable local echo"));
    c=new wxLayoutConstraints;
    c->top.Below(m_highlight,5);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_local_echo->SetConstraints(c);
    m_local_echo->Show();

    m_escape_chars=new wxCheckBox(this, Conf_EscapeChars, _T("Process escape characters from your input (like \\n)"));
    c=new wxLayoutConstraints;
    c->top.Below(m_local_echo,5);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_escape_chars->SetConstraints(c);
    m_escape_chars->Show();

    m_eol_rn=new wxRadioButton(this, Conf_Eol_rn, _T("EOL sequence is \\r\\n"));
    c=new wxLayoutConstraints;
    c->top.Below(m_escape_chars,5);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_eol_rn->SetConstraints(c);
    m_eol_rn->Show();

    m_eol_n=new wxRadioButton(this, Conf_Eol_n, _T("EOL sequence is \\n"));
    c=new wxLayoutConstraints;
    c->top.Below(m_eol_rn,5);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_eol_n->SetConstraints(c);
    m_eol_n->Show();

    m_eol_r=new wxRadioButton(this, Conf_Eol_r, _T("EOL sequence is \\r"));
    c=new wxLayoutConstraints;
    c->top.Below(m_eol_n,5);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_eol_r->SetConstraints(c);
    m_eol_r->Show();

    m_eol_nr=new wxRadioButton(this, Conf_Eol_r, _T("EOL sequence is \\n\\r"));
    c=new wxLayoutConstraints;
    c->top.Below(m_eol_r,5);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_eol_nr->SetConstraints(c);
    m_eol_nr->Show();

    m_ssl=new wxCheckBox(this, Conf_ssl, _T("Use SSL"));
    c=new wxLayoutConstraints;
    c->top.Below(m_eol_nr,5);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_ssl->SetConstraints(c);
    m_ssl->Show();

    //

    m_txt1=new wxStaticText(this, Conf_txt1, _T("File with certificates of Certificate Authorities you trust (PEM format)"), wxDefaultPosition, wxDefaultSize);
    c=new wxLayoutConstraints;
    c->top.Below(m_ssl,20);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_txt1->SetConstraints(c);
    m_txt1->Show();

    m_cas=new wxTextCtrl(this, Conf_cas, _T(""), wxDefaultPosition, wxDefaultSize, wxTE_PROCESS_ENTER);
    c=new wxLayoutConstraints;
    c->top.Below(m_txt1,5);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(20);
    m_cas->SetConstraints(c);
    m_cas->Show();

    m_cas_btn=new wxButton(this, Conf_cas_btn, _T("..."), wxDefaultPosition, wxDefaultSize);
    c=new wxLayoutConstraints;
    c->top.SameAs(m_cas,wxTop,0);
    c->left.RightOf(m_cas,0);
    c->height.Absolute(20);
    c->width.Absolute(30);
    m_cas_btn->SetConstraints(c);
    m_cas_btn->Show();

    //

    m_txt2=new wxStaticText(this, Conf_txt2, _T("File with your public certificate (PEM format)"), wxDefaultPosition, wxDefaultSize);
    c=new wxLayoutConstraints;
    c->top.Below(m_cas,8);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_txt2->SetConstraints(c);
    m_txt2->Show();

    m_crt=new wxTextCtrl(this, Conf_crt, _T(""), wxDefaultPosition, wxDefaultSize, wxTE_PROCESS_ENTER);
    c=new wxLayoutConstraints;
    c->top.Below(m_txt2,5);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(20);
    m_crt->SetConstraints(c);
    m_crt->Show();

    m_crt_btn=new wxButton(this, Conf_crt_btn, _T("..."), wxDefaultPosition, wxDefaultSize);
    c=new wxLayoutConstraints;
    c->top.SameAs(m_crt,wxTop,0);
    c->left.RightOf(m_cas,0);
    c->height.Absolute(20);
    c->width.Absolute(30);
    m_crt_btn->SetConstraints(c);
    m_crt_btn->Show();

    //

    m_txt3=new wxStaticText(this, Conf_txt2, _T("File with your private key for certificate (PEM format)"), wxDefaultPosition, wxDefaultSize);
    c=new wxLayoutConstraints;
    c->top.Below(m_crt,8);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(vertical_spacing);
    m_txt3->SetConstraints(c);
    m_txt3->Show();

    m_key=new wxTextCtrl(this, Conf_key, _T(""), wxDefaultPosition, wxDefaultSize, wxTE_PROCESS_ENTER);
    c=new wxLayoutConstraints;
    c->top.Below(m_txt3,5);
    c->left.Absolute(30);
    c->right.SameAs(this,wxWidth,+30+30);
    c->height.Absolute(20);
    m_key->SetConstraints(c);
    m_key->Show();

    m_key_btn=new wxButton(this, Conf_key_btn, _T("..."), wxDefaultPosition, wxDefaultSize);
    c=new wxLayoutConstraints;
    c->top.SameAs(m_key,wxTop,0);
    c->left.RightOf(m_key,0);
    c->height.Absolute(20);
    c->width.Absolute(30);
    m_key_btn->SetConstraints(c);
    m_key_btn->Show();

    m_ok_btn=new wxButton(this, Conf_ok_btn, _T("OK"), wxDefaultPosition, wxDefaultSize);
    c=new wxLayoutConstraints;
    c->top.Below(m_key,20);
    c->left.Absolute(30);
    c->height.Absolute(30);
    c->width.Absolute(30);
    m_ok_btn->SetConstraints(c);
    m_ok_btn->Show();
    m_ok_btn->SetDefault();

    Fit();
    Layout();
}

c_cnf_frame::c_cnf_frame(const wxString& title, const wxPoint& pos, const wxSize& size)
    : wxFrame((wxFrame *)NULL, -1, title, pos, size)
{
    m_panel=new c_cnf_panel(this);
}

extern void show_main();

void c_cnf_frame::OnClose(wxCloseEvent& WXUNUSED(event))
{
    show_main();
}

void c_cnf_panel::OnOkBtn(wxCommandEvent& WXUNUSED(event))
{
    show_main();
}

void c_cnf_panel::OnSslCheckBox(wxCommandEvent& WXUNUSED(event))
{
    bool on=m_ssl->GetValue();
    m_txt1->Show(on);
    m_cas->Show(on);
    m_cas_btn->Show(on);
    m_txt2->Show(on);
    m_crt->Show(on);
    m_crt_btn->Show(on);
    m_txt3->Show(on);
    m_key->Show(on);
    m_key_btn->Show(on);
}

void c_cnf_panel::OnCAs_btn(wxCommandEvent& WXUNUSED(event))
{
    m_open=new wxFileDialog(this,_T("Choose a file with Certificate Authorities you trust (in PEM format)"));
    m_open->SetWildcard(_T("Certificate files (*.crt)|*.crt"));
    if(m_open->ShowModal()==wxID_OK)
        m_cas->SetValue(m_open->GetPath());
    m_open->Destroy();
    delete m_open;
}

void c_cnf_panel::OnCrt_btn(wxCommandEvent& WXUNUSED(event))
{
    m_open=new wxFileDialog(this,_T("Choose a file with you public certificate (in PEM format)"));
    m_open->SetWildcard(_T("Certificate files (*.crt)|*.crt"));
    if(m_open->ShowModal()==wxID_OK)
        m_crt->SetValue(m_open->GetPath());
    m_open->Destroy();
    delete m_open;
}

void c_cnf_panel::OnKey_btn(wxCommandEvent& WXUNUSED(event))
{
    m_open=new wxFileDialog(this,_T("Choose a file with your private key to certificate (in PEM format)"));
    m_open->SetWildcard(_T("Private key files (*.key)|*.key"));
    if(m_open->ShowModal()==wxID_OK)
        m_key->SetValue(m_open->GetPath());
    m_open->Destroy();
    delete m_open;
}

