/***************************************************************************
                          compat.cpp  -  description
                             -------------------
    begin                : Thu Jul 31 2005
    copyright            : (C) 2005-2009  Marian VooDooMan Meravy
    email                : ghostvoodooman@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

XTelnet - a simple telnet client
Copyright (C) 2004,-2009  Marian VooDooMan Meravy
  (ghostvoodooman@users.sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides compatibility functions
*/

//---------------------------------------------------------------------------

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <string.h>

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <stdio.h>

#pragma hdrstop

#include "compat.h"

//#include "log.h"

using namespace std;

#if !defined(_WIN32) && !defined(HAVE_LTOA)
/*!
    \author VooDooMan
    \version 2
    \date 2004, 2005-07-31
    \brief ltoa() emulation for compiler which doesn't have it
    \param value Value to convert to string
    \param buffer Output string
    \param radix *MUST* be 10 or 16
    \return Returns buffer
    \bug radix MUST be 10 or 16!
*/
char *ltoa(long value, char *buffer, int radix)
{
    switch(radix) {
        case 10:
            sprintf(buffer,"%ld",(int)value);
            break;
        case 16:
            sprintf(buffer,"%x",(int)value);
            break;
        default:
            {
                strcpy(buffer,"ERRRADIX");
                /*
                string d="OOPS: This could be fatal! ltoa() radix MUST be 10 or 16! Please, report this problem!";
                log_debug(d);
                log_bot(d);
                */
            }
            break;
    }
    return buffer;
}
#endif

