/***************************************************************************
                          compat.h  -  description
                             -------------------
    begin                : Thu Jul 31 2005
    copyright            : (C) 2004-2009  Marian VooDooMan Meravy
    email                : ghostvoodooman@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

XTelnet - a simple telnet client
Copyright (C) 2004-2009  Marian VooDooMan Meravy
  (ghostvoodooman@users.sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides compatibility functions
*/

//---------------------------------------------------------------------------

#ifndef _COMPAT_H_
#define _COMPAT_H_

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#ifdef _MSC_VER
#define __func__ __FUNCTION__
#else
/*
#if __STDC_VERSION__ < 199901L
# if __GNUC__ >= 2
#  define __func__ __FUNCTION__
# else
#  define __func__ "<unknown-your_compiler_doesnt_support_this_feature>"
# endif
#endif
*/

static void dummy()
{
#ifdef __FUNCTION__
#   define FUNCTION_TEST __FUNCTION__
#endif

#ifdef __BORLANDC__
#   define FUNCTION_TEST __FUNC__
#endif

#ifdef __GNUC__
#   define FUNCTION_TEST __FUNCTION__
#endif
}

#if defined(HAVE___FUNCTION__) || defined(FUNCTION_TEST)
#   define __func__ __FUNCTION__
#else
#   define __func__ "<unknown-your_compiler_doesnt_support_this_feature>"
#endif

#if defined(FUNCTION_TEST)
#   undef __func__
#   define __func__ FUNCTION_TEST
#endif

#if !defined(HAVE___FILE__) && !defined(__FILE__)
#   define __FILE__ "<unknown-your_compiler_doesnt_support_this_feature>"
#endif

#if !defined(HAVE___LINE__) && !defined(__LINE__)
#   define __LINE__ (-1)
#endif

#endif

#if !defined(_WIN32) && !defined(HAVE_LTOA)
// WARNING: "radix" *MUST* be 10 or 16!
char *ltoa(long value, char *buffer, int radix);
#endif

#ifdef _WIN32
#   define FILE_SLASH       "\\"
#   define FILE_SLASH_CH    '\\'
#else
#   define FILE_SLASH       "/"
#   define FILE_SLASH_CH    '/'
#endif

/*
#ifdef __alpha
typedef unsigned int uint32;
#else
typedef unsigned long uint32;
#endif
*/

#if defined(HAVE_CONFIG_H)
#   if SIZEOF_LONG == 4
typedef unsigned long uint32;
#   else
#       if SIZEOF_INT == 4
typedef unsigned int uint32;
#       else
#           error Cannot define type 'uint32' to be 4 bytes long.
#       endif
#   endif
#else
#   ifdef __alpha
typedef unsigned int uint32;
#   else
typedef unsigned long uint32;
#   endif
#endif

#ifdef _WIN32
#   include <io.h>
#   include <process.h>
#endif

#ifndef _MSC_VER
#   ifdef _WIN32
#       include <dir.h>
#   else
#       include <sys/types.h>
#       include <sys/stat.h>
#       include <unistd.h>
#       include <fcntl.h>
#   endif
#else
#    include <direct.h>
#    define mkdir _mkdir
#endif

#ifndef HAVE_SSIZE_T
#   define ssize_t signed
#endif

#ifdef __BORLANDC__
typedef unsigned long uintptr_t;
#endif

#define MAXIMUM_SIGNED_INT          ((signed)(((unsigned)~-0L)/2L))

#endif

