/***************************************************************************
                          compat.h  -  description
                             -------------------
    begin                : Thu Jul 31 2005
    copyright            : (C) 2004-2009  Marian VooDooMan Meravy
    email                : ghostvoodooman@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************

XTelnet - a simple telnet client
Copyright (C) 2004-2009  Marian VooDooMan Meravy
  (ghostvoodooman@users.sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides event table
*/

// ----------------------------------------------------------------------------
// event tables and other macros for wxWindows
// ----------------------------------------------------------------------------

// the event tables connect the wxWindows events with the functions (event
// handlers) which process them. It can be also done at run-time, but for the
// simple menu events like this the static method is much simpler.
BEGIN_EVENT_TABLE(MyFrame, wxFrame)
    EVT_MENU(XTelnet_Tools_Quit,            MyFrame::OnQuit)
    EVT_MENU(XTelnet_Tools_About,           MyFrame::OnAbout)
    EVT_MENU(XTelnet_Tools_Disconnect,      MyFrame::OnDisconnect)
    EVT_MENU(XTelnet_Tools_Paste,           MyFrame::OnPaste)
    EVT_MENU(XTelnet_Tools_Paste_Record,    MyFrame::OnPasteRecord)
    EVT_MENU(XTelnet_Tools_RecordLog,       MyFrame::OnRecordLog)
    EVT_MENU(XTelnet_Tools_ClearBuff,       MyFrame::OnClearBuff)
    EVT_MENU(XTelnet_Tools_Hide,            MyFrame::OnHide)

    EVT_MENU(XTelnet_Up,                    MyFrame::OnUp)
    EVT_MENU(XTelnet_Down,                  MyFrame::OnDown)
    EVT_MENU(XTelnet_F7,                    MyFrame::OnF7)
    EVT_MENU(XTelnet_Esc,                   MyFrame::OnEsc)

    EVT_CHAR_HOOK(                          MyFrame::OnChar)

    EVT_LISTBOX(XTelnet_Iterator_Ctrl,      MyFrame::OnSelected)

    EVT_TEXT_ENTER(XTelnet_Enter_Ctrl,      MyFrame::OnEnter)

    EVT_CHECKBOX(XTelnet_Pasw_Ctrl,         MyFrame::OnPassword)

    EVT_CLOSE(                              MyFrame::OnClose)

    EVT_IDLE(MyFrame::OnIdle)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(MyPanel, wxPanel)
    EVT_TIMER(XTelnet_Timer,                MyPanel::OnTimer)
    EVT_TIMER(XTelnet_Loop,                 MyPanel::OnLoop)
END_EVENT_TABLE()

DECLARE_APP(MyApp);

// Create a new application object: this macro will allow wxWindows to create
// the application object during program execution (it's better than using a
// static object for many reasons) and also declares the accessor function
// wxGetApp() which will return the reference of the right type (i.e. MyApp and
// not wxApp)
IMPLEMENT_APP(MyApp);

